//
//  GetCompanyCode.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 04/05/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import SwiftUI
import Combine
import FirebaseFirestore

class GetCompanyCode:ObservableObject {
    
    @Published var code = ""
    
    private let empresaId: String = UserDefaults.standard.object(forKey: "EmpresaID") as! String
    
    init() {
        self.obtenCodigoQR()  
    }
    
    //Función para obtener el código QR de la empresa
    private func obtenCodigoQR(){
        
        let db = Firestore.firestore()
        // Creamos la referencia a la empresa
        let ref = db.collection("empresas").document(self.empresaId)
        
        // Consultamos las empresas
        ref.addSnapshotListener(){ (empresa,error) in
            //capturamos los errores
            if error != nil{
                print("Error", error ?? "Fallo")
            }else{
                let code = empresa!.data()!["code"] as? String ?? ""
                
                DispatchQueue.main.async {
                    self.code = code
                }
            }
            
            
        }
        
    }
    
}
