//
//  GetCompanyUser.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 14/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import SwiftUI
import Combine
import FirebaseFirestore

class GetCompanyUser:ObservableObject {
    
    @Published var empresa = Empresa(id: "", nombre: "", cif: "", direccion:"", telefono:"", fax:"")
    private var encontrado: Bool = false
    
    init(user: String) {
        self.identificaEmpresaByUsuario(user: user)
         
    }
    
    init(){
       //self.identificaEmpresaByUsuario(user: "eperianes@dos.com")
       // self.identificaEmpresaByUsuario(user: Auth.auth().currentUser!.email!)
    }
    
    //Función para identificar la empresa del usuario registrado
    private func identificaEmpresaByUsuario(user:String){
        
        let db = Firestore.firestore()
        // Creamos la referencia a la colección de empresas
        let ref = db.collection("empresas")
        
        // Consultamos las empresas
        ref.getDocuments(){ (empresa,error) in
            //capturamos los errores
            if error != nil{
                print("Error", error ?? "Fallo")
            }else{
                //recorremos las empresas
                for documento in empresa!.documents{
                    if self.encontrado == false{  //evitamos leer el resto de documentos cuando encontramos al usuario
                        //creamos referencia a la coleccion de usuarios
                        let ref1 = ref.document(documento.documentID).collection("users").whereField("mail", isEqualTo: user)
                        //Consultamos si el usuario pertenece a la empresa
                        ref1.getDocuments() { (usuarios,error) in
                            //si exite guardamos la informacion de la empresa y el usuario
                            if usuarios!.count > 0{
                                for usuario in usuarios!.documents{
                                    let userId = usuario.documentID
                                    UserDefaults.standard.set(userId, forKey: "UserID")
                                    let userName = usuario.data()["nombre"] as? String ?? ""
                                    UserDefaults.standard.set(userName, forKey: "UserName")
                                    let code = usuario.data()["codigo"] as? String ?? ""
                                    UserDefaults.standard.set(code, forKey: "UserCode")
                                    let isAdmin = usuario.data()["isAdmin"] as? Bool ?? false
                                    UserDefaults.standard.set(isAdmin, forKey: "isAdmin")
                                    let companyId = documento.documentID
                                    UserDefaults.standard.set(companyId, forKey: "EmpresaID")
                                    let name = documento.data()["nombre"] as? String ?? "Empresa"
                                    UserDefaults.standard.set(name, forKey: "Empresa")
                                    let cif = documento.data()["cif"] as? String ?? ""
                                    let direccion = documento.data()["direccion"] as? String ?? ""
                                    let telefono = documento.data()["telefono"] as? String ?? ""
                                    let fax = documento.data()["fax"] as? String ?? ""
                                    
                                    self.empresa.id = companyId
                                    self.empresa.cif = cif
                                    self.empresa.nombre = name
                                    self.empresa.direccion = direccion
                                    self.empresa.telefono = telefono
                                    self.empresa.fax = fax
                                    
                                    self.encontrado = true
                                    
                                }
                              
                            }
                            
                        }
                    }
                    
                    
                }
            }
            
            
        }
        
    }
    
}


