//
//  GetEventos.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 07/05/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import Combine
import FirebaseFirestore
import SwiftUI

class GetEventos:ObservableObject{
    
    private var empresaID: String = UserDefaults.standard.object(forKey: "EmpresaID") as! String

    @Published var eventos = [Evento]()
  
    init(){
        self.obtenEventos()
    }
    
    //Función para obtener los anuncios de la empresa del usuario registrado
    func obtenEventos(){
        let db = Firestore.firestore()
        // creamos referencia a la coleccion de eventos
        let ref = db.collection("empresas").document(self.empresaID).collection("eventos").order(by: "inicio", descending: false)
        // creamos un listener para actualizar la lista de eventos cuando estos cambien
        ref.addSnapshotListener{ (eventos,error) in
            if error != nil{
                print("Error")
            }else{
                self.eventos.removeAll()
                for evento in eventos!.documents{
                    
                    let id = evento.documentID
                    let usuario = evento.data()["usuario"] as? String ?? ""
                    let inicio = evento.data()["inicio"] as? Timestamp ?? Timestamp(date: Date())
                    let fin = evento.data()["fin"] as? Timestamp ?? Timestamp(date: Date())
                    let descripcion = evento.data()["evento"] as? String ?? ""
                    let observaciones = evento.data()["observaciones"] as? String ?? ""
                    DispatchQueue.main.async {
                        let registro = Evento(id: id, inicio: inicio.dateValue(), fin: fin.dateValue(), usuario: usuario, evento: descripcion, observaciones:observaciones)
                        self.eventos.append(registro)
                    }
                }
            }
            
        }
    }
}
