//
//  GetUser.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 15/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import SwiftUI
import Combine
import FirebaseFirestore

class GetUser:ObservableObject {
    @Published var user = Usuario(id: "", mail: "", isAdmin: false, nombre: "", apellidos: "", movil: "", telefono: "", codigo: "")
    private var empresaID = UserDefaults.standard.object(forKey: "EmpresaID") as! String
    
    init(user: String) {
        self.identificaUsuario(user: user)
        
    }
   
    //Función para identificar el usuario registrado
    private func identificaUsuario(user:String){
       
        let db = Firestore.firestore()
        // Creamos la referencia a la colección de usuarios
        let ref = db.collection("empresas").document(self.empresaID).collection("users")
    
        //Buscamos el documento correspondiente al usuario
        ref.whereField("mail", isEqualTo: user).getDocuments() { (usuarios,error) in
            //si exite guardamos la informacion de la empresa y el usuario
            
            for usuario in usuarios!.documents{
                self.user.id = usuario.documentID
                self.user.isAdmin = usuario.data()["isAdmin"] as? Bool ?? false
                self.user.mail = usuario.data()["mail"] as? String ?? ""
                self.user.nombre = usuario.data()["nombre"] as? String ?? ""
                self.user.apellidos = usuario.data()["apellidos"] as? String ?? ""
                self.user.movil = usuario.data()["movil"] as? String ?? ""
                self.user.telefono = usuario.data()["telefono"] as? String ?? ""
                self.user.codigo = usuario.data()["codigo"] as? String ?? ""
                
            }
            
        }
    }
}


