//
//  GetUsers.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 14/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import Combine
import FirebaseFirestore
import SwiftUI

class GetUsers:ObservableObject{
    
    private var empresaID: String = UserDefaults.standard.object(forKey: "EmpresaID") as! String
    @Published var users = [Usuario]()
  
    init(){
        obtenUsuarios()
    }
    
    //Función para obtener los usuarios de una empresa del usuario registrado
    func obtenUsuarios(){
        
        let db = Firestore.firestore()
        // creamos referencia a la coleccion de usuarios
        let ref = db.collection("empresas").document(self.empresaID).collection("users")
        // creamos un listener para actualizar la lista de usuarios cuando estos cambien
        ref.addSnapshotListener{ (usuarios,error) in
            if error != nil{
                print("Error")
            }else{
                self.users.removeAll()
                for usuario in usuarios!.documents{
                    
                    let id = usuario.documentID
                    let isAdmin = usuario.data()["isAdmin"] as? Bool ?? false
                    let mail = usuario.data()["mail"] as? String ?? ""
                    let nombre = usuario.data()["nombre"] as? String ?? ""
                    let apellidos = usuario.data()["apellidos"] as? String ?? ""
                    let movil = usuario.data()["movil"] as? String ?? ""
                    let telefono = usuario.data()["telefono"] as? String ?? ""
                    let codigo = usuario.data()["codigo"] as? String ?? ""
                   
                    DispatchQueue.main.async {
                    let registro = Usuario(id: id, mail: mail, isAdmin: isAdmin, nombre: nombre, apellidos: apellidos, movil: movil, telefono: telefono, codigo: codigo)
                    self.users.append(registro)
                    }
                }
            }
            
        }
    }
}
