//
//  modelo.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 13/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation

struct Empresa {
    var id: String
    var nombre:String
    var cif: String
    var direccion: String
    var telefono: String
    var fax: String
}

struct Usuario:Identifiable {
    var id: String
    var mail: String
    var isAdmin: Bool
    var nombre: String
    var apellidos: String
    var movil: String
    var telefono: String
    var codigo: String
}
struct Evento: Identifiable{
    var id: String
    var inicio: Date
    var fin: Date
    var usuario: String
    var evento:String
    var observaciones:String
}
struct Proyecto:Identifiable {
    var id: String
    var nombre: String
    var cliente: String
    var responsable: String
    var inicio: Date
    var entrega: Date
    var estado: String
    var mensaje: String
}
struct Anuncio:Identifiable {
    var id: String
    var titulo: String
    var usuario: String
    var fecha: Date
    var prioridad: Int
    var anuncio: String
}

struct Ausencia:Identifiable, Equatable{ //Equalable para poder localizar el índice la ausencia en un vector
    var id: String
    var tipo: String
    var inicio: Date
    var fin: Date
    var adjunto: String
    var estado: String
    var observaciones: String
    var user:String
    var userID:String //en primer lugar será el email de usuario y después su documentID de Firestone
}

struct Dia:Identifiable {
    var id: String
    var inicio: Date
    var fin: Date
    var locInicio: String
    var locFin: String
    var totalDescansosDia: Double
}

struct Descanso:Identifiable {
    var id: String
    var inicio: Date
    var fin: Date
}


