//
//  NetMonitor.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 03/05/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import Foundation
import Network
 
class NetMonitor: ObservableObject {

    private var monitor: NWPathMonitor
    private var queue = DispatchQueue.global()
    
    @Published var isConnected: Bool = true
 
    init() {
        self.monitor = NWPathMonitor()
        self.queue = DispatchQueue.global(qos: .background)
        self.monitor.start(queue: queue)
    }
 
    func startMonitoring() {
        self.monitor.pathUpdateHandler = { path in
            DispatchQueue.main.async { //modificamos la variable publicada de forma asíncrona para evitar publicar cambios en el hilo principal
                if path.status == .satisfied {
                    self.isConnected = true
                }else{
                    self.isConnected = false
                }
            }
        }
    }
 
    func stopMonitoring() {
        self.monitor.cancel()
    }
 
}
