//
//  CustomLogin.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 19/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct FieldLoginView: View {
    
    @Binding var texto: String
    @State private var isSecure:Bool = true
    
    var isEmail: Bool = false
    var isPass: Bool = false
    var isRepass: Bool = false
    var isCompany: Bool = false
    
    
    var body: some View{
        
        VStack{
            
            HStack{
                if isEmail{ //email
                    HStack{
                        TextField("e-mail", text: self.$texto)
                            .foregroundColor(Color.black)
                            .font(.body)
                            .textContentType(.emailAddress)
                            .keyboardType(.emailAddress)
                            .autocapitalization(.none)
                        Image (systemName: "envelope.fill")
                                .foregroundColor(Color("ColorLogo"))
                    }
                   
                }else if isPass{ //password
                    HStack{
                        if isSecure{
                            SecureField("Password", text: self.$texto)
                            .foregroundColor(Color.black)
                            .font(.body)
                            .autocapitalization(.none)
                        }else{
                            TextField("Password", text: self.$texto)
                            .foregroundColor(Color.black)
                            .font(.body)
                            .autocapitalization(.none)
                        }
                        
                        Button(action: {
                            self.isSecure.toggle()
                        }){
                            Image (systemName: "eye.slash.fill")
                                .foregroundColor(Color("ColorLogo"))
                                
                        }
                    }
                }else if isRepass{ //repetir password
                    HStack{
                        if isSecure{
                            SecureField("Repite Password", text: self.$texto)
                            .foregroundColor(Color.black)
                            .font(.body)
                            .autocapitalization(.none)
                        }else{
                            TextField("Repite Password", text: self.$texto)
                            
                            .foregroundColor(Color.black)
                            .font(.body)
                            .autocapitalization(.none)
                        }
                        
                        Button(action: {
                            self.isSecure.toggle()
                        }){
                            Image (systemName: "eye.slash.fill")
                                .foregroundColor(Color("ColorLogo"))
                                
                        }
                    }
                }else if isCompany{ //nombre de empresa
                    TextField("Nombre", text: self.$texto)
                    .foregroundColor(Color.black)
                    .font(.body)
                    .autocapitalization(.none)
                }else{ //CIF de empresa
                    TextField("CIF", text: self.$texto)
                    .foregroundColor(Color.black)
                    .font(.body)
                    .autocapitalization(.none)
                }
                
                
            }.padding(.horizontal,20)
            
            Divider().padding(.horizontal,20)
        }//Fin Vstack principal
    }
}


struct FieldLogingView_Previews: PreviewProvider {
    @State private var textoTipo: String = ""
    static var previews: some View {
        FieldLoginView(texto: .constant(""))
    }
}
