//
//  HomeView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 20/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct HomeView: View {
   
    @State private var index :Int = 0
    @State private var selection: Int = 0
   
    @State var showMenu: Bool = false
 
    @State private var code: String = ""
    
    @ObservedObject var empresa = GetCompanyUser(user: UserDefaults.standard.object(forKey: "UserMail") as? String ?? "edu@pruebas.com")
    //@ObservedObject var empresa = GetCompanyUser(user: "eperianes@uno.com")
    
    //declaramos el monitor de conexión
    @ObservedObject var netMonitor: NetMonitor
 
    
    init(){
        //inicializamos y arrancamos el monitor de conexión a la red
        self.netMonitor = NetMonitor()
        self.netMonitor.startMonitoring()
    }
    
    var body: some View {
        ZStack{
            //Vistas
            if self.netMonitor.isConnected{
                VStack{
                    if self.index == 0 {
                        BaseHorarioView(selected: self.$selection)
                        .padding(.bottom,50)
                    }else if self.index == 1{
                        AusenciasView()
                          .padding(.bottom,50)
                    }else if self.index == 2{
                        AgendaView()
                          .padding(.bottom,50)
                    }else if self.index == 3{
                        ProyectosView()
                          .padding(.bottom,50)
                    }else {
                        TablonView()
                            .padding(.bottom,50)
                    }
                }
                    //TabBar principal
                    VStack{
                        Spacer()
                        TabBarView(index: self.$index)
                    }.edgesIgnoringSafeArea(.bottom)
                    
                    //Botón principal
                    VStack{
                        Spacer()
                        HStack{
                            Spacer()
                            BotonView()
                                .padding(.bottom,60)
                        }
                        
                    }
            }else{
                NoNetView()
                //TabBar principal
                VStack{
                    Spacer()
                    TabBarView(index: self.$index)
                }.edgesIgnoringSafeArea(.bottom)
            }
            
        }
    }
}



struct HomeView_Previews: PreviewProvider {
    static var previews: some View {
        HomeView()
    }
}

