//
//  HorarioView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 21/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI
import FirebaseFirestore

struct HorarioView: View {
    
    @EnvironmentObject var today: Jornada
    
    @State private var isStarted: Bool = false
    @State private var isPaused: Bool = false
    @State private var withSeconds: Bool = false
    
    private var dateFormat: DateFormatter{
        let format = DateFormatter()
        format.dateFormat = "dd MMMM yyyy"
        return format
    }
    private var mainTimeFormat: DateFormatter{
           let format = DateFormatter()
        format.dateFormat = "HH:mm"
           return format
       }

    private var dayFormat: DateFormatter{
        let format = DateFormatter()
        format.dateFormat = "EEEE"
        return format
    }
    
    var body: some View {
        VStack{
            //Fecha y hora actual
            VStack{
                Text("\(self.today.now,formatter: self.mainTimeFormat)")
                    .font(.largeTitle)
                
                Text("\(self.today.now,formatter: self.dateFormat)")
                Text("\(self.today.now,formatter: self.dayFormat)")
            }.padding(.bottom,30).padding(.top,20)
                
            
            HStack{
                Text("Hoy").bold()
                    .padding(.horizontal)
                    .padding(.vertical,7)
                Spacer()
            }.background(Color("Barras"))
            
            //Fichaje
            VStack{
               HStack{
                    Text("Has empezado a las: ")
                    Spacer()
                Text(self.today.fichaje).bold()
                }.padding(.horizontal).padding(.top,7)
                
                Divider()
                
                VStack{
                    HStack{
                        Text("Has fichado en: ")
                        Spacer()
                    }
                    VStack(alignment: .center){
                        Text(self.today.direccion).foregroundColor(.blue)
                        Text(self.today.localidad).foregroundColor(.blue)
                    }.padding(.vertical,7)
                    
                }.padding(.horizontal)
                
            }.background(Color.white)
             
               
            
            HStack{
                 Text("Acumulados").bold()
                 .padding(.horizontal)
                 .padding(.vertical,7)
                 Spacer()
                
            }.background(Color("Barras"))
             
            VStack{
                //Contadores
                 HStack {
                     Text("Tiempo trabajado: ")
                     Spacer()
                    Text(self.today.obtenTotalTrabajado(full: true))
                 } .padding(.horizontal).padding(.top,7)
                  Divider()
                 HStack {
                     Text("Tiempo de descanso: ")
                     Spacer()
                    Text(self.today.obtenDiferencia(desde: self.today.inicioDescanso, hasta: self.today.finDescanso, full: true, isDescanso: true))
                 } .padding(.horizontal)
                  Divider()
                 HStack {
                     Text("Total desde el inicio: ")
                     Spacer()
                    Text(self.today.obtenDiferencia(desde: self.today.inicio, hasta: self.today.final, full: true, isDescanso: false))
                    
                 } .padding(.horizontal).padding(.bottom,5)
                Divider()
                
            }.background(Color.white)

        }
    }
    
}


struct HorarioView_Previews: PreviewProvider {
    static var previews: some View {
        HorarioView()
    }
}
