//
//  RegistroUsersView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 01/05/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct RegistroUsersView: View {
    
    @Binding var show: Bool
    
    @ObservedObject var datos = GetUsers()
    
    let adminMail = UserDefaults.standard.object(forKey: "UserMail") as! String
    
    var body: some View {
        NavigationView{
            VStack {
                Divider().padding(.horizontal)
                List{
                    ForEach (self.datos.users){ user in
                        if user.mail != self.adminMail{ //mostramos todos los usuarios menos el registrado actualmente
                            NavigationLink(destination: RegistroHorarioView(user: user.id, username: user.nombre)){
                                VStack{
                                    HStack{
                                        Text("\(user.nombre) "+"\(user.apellidos)").bold()
                                        Spacer()
                                    }.padding(.bottom,7)
                                    HStack{
                                        Text(user.mail)
                                        Spacer()
                                        if user.isAdmin{
                                            Text("Administrador").foregroundColor(.orange)
                                        }else{
                                            Text("Usuario").foregroundColor(.green)
                                        }
                                        
                                    }
                                    
                                }
                            }
                        }
                        
                    }
                    
                    
                    
                }
            }
            .navigationBarTitle("Usuarios", displayMode: .inline)
        .navigationBarItems(leading:
            Button(action:{
                self.show.toggle()
                
            }){
                HStack{
                    Image(systemName: "chevron.left")
                        .resizable()
                        .frame(width: 10, height: 15)
                    Text("Volver").padding(.leading,-5)
                    Spacer()
                }
                
            }
        )
                       
        }
           .navigationBarTitle("")
           .navigationBarHidden(true)
                      
    }

}

struct RegistroUsersView_Previews: PreviewProvider {
    static var previews: some View {
        RegistroUsersView(show: .constant(false))
    }
}
