//
//  EmpresaDetailView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 16/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI
import FirebaseFirestore

struct EmpresaDetailView: View {
       @Binding var show: Bool
       @Binding var showMenu: Bool
       
       let isAdmin:Bool = UserDefaults.standard.object(forKey: "isAdmin") as! Bool
       
       @State private var isEdit:Bool = false
       @State private var showAlert = false
       @State private var hayError = false
       @State private var textAlert = ""
    
    @State private var offsetTeclado: CGFloat = 0
    @State private var needTeclado = false
       
    @ObservedObject var datos = HomeView().empresa
       
    //Función para actualizar los datos de usuario en la base de datos
     private func actualizaEmpresa(){
           let empresa = self.datos.empresa
           let db = Firestore.firestore()
        let campos : [String: Any] = ["nombre": empresa.nombre,"cif": empresa.cif,"direccion":empresa.direccion , "telefono": empresa.telefono, "fax":empresa.fax]
           db.collection("empresas").document(UserDefaults.standard.object(forKey: "EmpresaID") as! String).updateData(campos){(error) in
               if error != nil{
                   self.textAlert = "¡Error al actualizar empresa!"
                   //print(error!.localizedDescription)
               }else{
                   UserDefaults.standard.set(empresa.nombre, forKey: "Empresa")
                   self.textAlert = "¡Empresa actualizado corréctamente!"
               }
           }
       }

       var body: some View {
           
           NavigationView{
               VStack{
                   
                   //Cuerpo
                VStack{
                    if isEdit{
                        //Nombre
                        HStack{
                            
                            Text("Nombre: ").foregroundColor(.green)
                            HStack{
                                
                                HStack{
                                    TextField("Nombre", text: self.$datos.empresa.nombre)
                                        .onTapGesture {
                                            self.needTeclado = false
                                    }
                                    Spacer()
                                    
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                            
                        }.padding()
                            .background(Color("Fondo").opacity(0.6)).cornerRadius(10)
                            .padding(.top)
                    }else{
                        //Nombre
                        HStack{
                            
                            Text("Nombre: ")
                            HStack{
                                
                                HStack{
                                    TextField("Nombre", text: self.$datos.empresa.nombre).disabled(true)
                                    Spacer()
                                    
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                            
                        }.padding()
                            .background(Color("Fondo").opacity(0.6)).cornerRadius(10)
                            .padding(.top)
                    }
                    
                      //Datos
                      //Si editamos
                      if isEdit{
                       
                           VStack{
                               
                               //CIF
                               HStack{
                                   Text("CIF:         ").foregroundColor(.green)
                                   HStack{
                                    TextField("CIF", text: self.$datos.empresa.cif)
                                    .onTapGesture {
                                            self.needTeclado = false
                                    }
                                       Spacer()
                                   }.padding(.horizontal).padding(.vertical,10)
                                       .background(Color.white).cornerRadius(10)
                               }
                               
                               //Telefono
                               HStack{
                                   Text("Teléfono:").foregroundColor(.green)
                                   HStack{
                                    TextField("Teléfono", text: self.$datos.empresa.telefono)
                                    .onTapGesture {
                                            self.needTeclado = false
                                    }
                                       Spacer()
                                   }.padding(.horizontal).padding(.vertical,10)
                                       .background(Color.white).cornerRadius(10)
                               }
                               
                               //Fax
                               HStack{
                                   Text("Fax:         ").foregroundColor(.green)
                                   HStack{
                                    TextField("Fax", text: self.$datos.empresa.fax)
                                    .onTapGesture {
                                            self.needTeclado = false
                                    }
                                       Spacer()
                                   }.padding(.horizontal).padding(.vertical,10)
                                       .background(Color.white).cornerRadius(10)
                               }
    
                               //Dirección
                               VStack{
                                   HStack{
                                    Text("Dirección:").foregroundColor(.green)
                                       Spacer()
                                   }.padding(.vertical,10)
                                   
                                   HStack{
                                    TextField("Dirección",text: self.$datos.empresa.direccion)
                                    .onTapGesture {
                                            self.needTeclado = true
                                    }
                                       Spacer()
                                   }.padding(.horizontal).padding(.vertical,10)
                                       .background(Color.white).cornerRadius(10)
                               }
                              
                           }.padding().background(Color("Fondo").opacity(0.6)).cornerRadius(10)
                       }else{
                        VStack{
                            
                            //CIF
                            HStack{
                                Text("CIF:         ")
                                HStack{
                                    TextField("CIF", text: self.$datos.empresa.cif).disabled(true)
                                    Spacer()
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                            //Telefono
                            HStack{
                                Text("Teléfono:")
                                HStack{
                                    TextField("Teléfono", text: self.$datos.empresa.telefono).disabled(true)
                                    Spacer()
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                            //Fax
                            HStack{
                                Text("Fax:         ")
                                HStack{
                                    TextField("Fax", text: self.$datos.empresa.fax).disabled(true)
                                    Spacer()
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                            //Dirección
                            VStack{
                                HStack{
                                    Text("Dirección:")
                                    Spacer()
                                }.padding(.vertical,10)
                                
                                HStack{
                                    Text(self.datos.empresa.direccion).disabled(true)
                                    Spacer()
                                }.padding(.horizontal).padding(.vertical,10)
                                    .background(Color.white).cornerRadius(10)
                            }
                            
                        }.padding().background(Color("Fondo").opacity(0.6)).cornerRadius(10)
                    }
                    
                    
                   }.padding(.horizontal).background(Color.white)
                Spacer()
               }.onAppear(){
                       //calculamos la altura del teclado
                       NotificationCenter.default.addObserver(forName: UIResponder.keyboardWillShowNotification, object: nil, queue: .main) { (notification) in
                           let teclado = notification.userInfo![UIResponder.keyboardFrameEndUserInfoKey] as! CGRect
                           let altura = teclado.height
                           if self.needTeclado{
                            self.offsetTeclado = altura/2.5
                           }
                         
                       }
                       
                       NotificationCenter.default.addObserver(forName: UIResponder.keyboardWillHideNotification, object: nil, queue: .main) { (notification) in
                           self.offsetTeclado = 0
                       }
               }
               .navigationBarTitle("Empresa")
                .navigationBarItems(leading:
                    Button(action:{
                        self.showMenu.toggle()
                        self.show.toggle()
                    }){
                        Text("Salir")
                        
                        
                    },trailing:
                    Button(action:{
                        if self.isEdit{
                            self.actualizaEmpresa()
                            self.showAlert.toggle()
 
                        }else{
                            self.isEdit.toggle()
                        }
                        
                    }){
                        if self.isAdmin{
                            if self.isEdit{
                                Text("Guardar")
                            }else{
                                Text("Editar")
                            }
                            
                        }else{
                            Text("")
                        }
                        
                }).alert(isPresented: self.$showAlert){
                    Alert(title: Text("Actualizar usuario"), message: Text(self.textAlert), dismissButton: .default(Text("Aceptar"), action:{
                        self.showMenu.toggle()
                        self.show.toggle()
                        
                        
                    }))
            }
            
            
           }.offset(y:-self.offsetTeclado)
            //Mejoramos la navegacion
            .navigationBarHidden(true)
            .navigationBarTitle("")
    }
}

struct EmpresaDetailView_Previews: PreviewProvider {
    static var previews: some View {
        EmpresaDetailView(show: .constant(false), showMenu: .constant(false))
    }
}
