//
//  AnuncioView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 23/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI
import FirebaseFirestore

struct AnuncioView: View {
    var datos:Anuncio
    let format = DateFormatter()
    
    func obtenFecha() -> String{
        
        var fecha: String = ""
        
        self.format.dateFormat = "dd/MM/yyyy HH:mm"
        fecha = format.string(from: self.datos.fecha)
        return fecha
    }
    
    var body: some View {
        VStack{
            VStack{
                HStack{
                    HStack{
                        Text("\(self.datos.titulo)").bold().foregroundColor(.white).font(.custom("arial", size: 18))
                        Spacer()
                        if self.datos.prioridad == 0{
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.white)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.white)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                        }else if self.datos.prioridad == 1{
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.white)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                        }else{
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                            Image(systemName: "star.fill").resizable().frame(width: 20, height: 20).foregroundColor(.yellow)
                        }
                    }
                    
                    
                }.padding(.horizontal)
                    .padding(.vertical,10)
                    .background(Color.green)
                
                VStack(alignment: .leading){
                    HStack(alignment: .top){
                        Text("Autor: ")
                        Text("\(self.datos.usuario)").bold()
                        Spacer()
                    }.padding(.bottom,5)
                    HStack{
                        Text("Fecha:")
                        Text(self.obtenFecha())
                    }.padding(.bottom)
                    
                    Text("Mensaje:").padding(.bottom,5)
                    HStack{
                        Text("\(self.datos.anuncio)")
                        
                        Spacer()
                    }.padding()
                        .background(Color("Fondo").opacity(0.6))
                        .cornerRadius(10)
                    
                    
                }.padding(.horizontal).padding(.bottom)
                
                
            }
            .background(Color.white)
            .cornerRadius(10)
            .shadow(color: .black, radius: 2)
        }.padding(.horizontal)
        
        
    }
}

struct AnuncioView_Previews: PreviewProvider {
    static var previews: some View {
        AnuncioView(datos: Anuncio(id: "", titulo: "Anuncio", usuario: "Edu (eperianes@eperianes.com)", fecha: Date(), prioridad: 0, anuncio: "Hola"))
    }
}
