//
//  TopBarView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 20/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct BotonView: View {
    
   
    @State private var showQR:Bool = false
    @State private var expand: Bool = false
    @State private var isButton: Bool = false
    @State private var textAlert:String = ""
    @State private var showAlert:Bool = false
    
    @EnvironmentObject var today: Jornada
    
    private let geoCode: String = UserDefaults.standard.object(forKey: "UserCode") as! String
    
       
    var body: some View {
        ZStack{
            NavigationLink(destination: LectorView(show: self.$showQR, isStarted: self.$today.isStarted), isActive: self.$showQR){
                EmptyView()
            }
            VStack{
                if self.isButton{
                    HStack{
                        Spacer()
                        Button(action:{
                            self.isButton.toggle()
                            
                        }){
                            if self.today.isStarted{
                                if self.today.isPaused{
                                    ZStack{
                                        Circle().foregroundColor(Color.green).frame(width: 90, height: 90).shadow(radius: 10)
                                        Image(systemName: "chevron.left")
                                            .resizable().frame(width: 50, height: 50).padding(.trailing)
                                        .foregroundColor(.white)
                                    }
                                }else{
                                    ZStack{
                                        Circle().foregroundColor(Color.orange).frame(width: 90, height: 90).shadow(radius: 10)
                                        Image(systemName: "chevron.left")
                                        .resizable().frame(width: 50, height: 50).padding(.trailing)
                                        .foregroundColor(.white)
                                    }
                                }
                            }else{
                                ZStack{
                                    Circle().foregroundColor(Color("ColorLogo")).frame(width: 90, height: 90).shadow(radius: 10)
                                    Image(systemName: "chevron.left")
                                    .resizable().frame(width: 50, height: 50).padding(.trailing)
                                    .foregroundColor(.white)
 
                                }
                            }
                            
                            
                        }
                    }.padding(.vertical,30)
                        .offset(x: 65)
                    
                }else{
                    if self.today.isStarted{
                        if self.today.isPaused{
                            HStack{
                                //Botón expandido
                                if self.expand{
                                    //Reanudar
                                    VStack{
                                        Button(action:{
                                            self.today.finalizarDescanso()
                                            self.expand.toggle()
                                        }){
                                            VStack{
                                                Image(systemName: "play.circle")
                                                    .resizable()
                                                    .padding()
                                                    .frame(width: 60, height: 60)
                                            }
                                            
                                            
                                        }.alert(isPresented: self.$today.showAlert){
                                            Alert(title: Text("Fichajes"), message: Text(self.today.textAlert), dismissButton: .default(Text("Aceptar"),action: {
                                                 self.expand.toggle()
                                            }))
                                        }
                                        .foregroundColor(Color.white)
                                        .background(Color.green)
                                        .clipShape(Circle()).shadow(radius: 10)
                                        
                                        Text("Reanudar").font(.subheadline).foregroundColor(Color.green).bold().shadow(radius: 10)
                                    }
                                    .padding(.horizontal,20)
                                }
                            
                                    ZStack{
                                        Circle().foregroundColor(Color.green).frame(width: 90, height: 90).shadow(radius: 10)
                                        Text("Fichar").foregroundColor(.white).font(.custom("Arial", size: 22))
                                   
                                }.onTapGesture{
                                    self.expand.toggle()
                                }
                                .onLongPressGesture {
                                    self.isButton.toggle()
                                }
                                
                                
                            }.padding(.horizontal).padding(.vertical,30)
                        }else{
                            HStack{
                                //Botón expandido
                                if self.expand{
                                    //GPS
                                    VStack{
                                        Button(action:{
                                            if self.geoCode.isEmpty{
                                                self.textAlert = """
                                                Error:
                                                Su perfil no puede iniciar la jornada con geolocalización. Actualice su perfil o póngase en contacto con un administrador.
                                                """
                                                self.showAlert.toggle()
                                               
                                            }else{
                                                self.today.finalizarDia(isGPS: true)
                                                self.expand.toggle()
                                            }
                                            
                                        }){
                                            VStack{
                                                Image(systemName: "mappin.and.ellipse")
                                                    .resizable()
                                                    .padding()
                                                    .frame(width: 60, height: 60)
                                            }
                                            
                                            
                                        }.alert(isPresented: self.$today.showAlert){
                                            Alert(title: Text("Fichajes"), message: Text(self.today.textAlert), dismissButton: .default(Text("Aceptar"),action: {
                                                 self.expand.toggle()
                                            }))
                                        }
                                        .foregroundColor(Color.white)
                                        .background(Color.orange)
                                        .clipShape(Circle()).shadow(radius: 10)
                                        
                                        Text("GPS").font(.subheadline).foregroundColor(Color.orange).bold().shadow(radius: 10)
                                    }
                                    //QRCode
                                    VStack{
                                        Button(action:{
                                             //self.today.finalizarDia(isGPS: false)
                                                self.showQR.toggle()
                                               self.expand.toggle()
                                        }){
                                            Image(systemName: "qrcode.viewfinder")
                                                .resizable()
                                                .padding()
                                                .frame(width: 60, height: 60)
                                            
                                        }
                                        .foregroundColor(Color.white)
                                        .background(Color.orange)
                                        .clipShape(Circle()).shadow(radius: 10)
                                        
                                        Text("QR Code").font(.subheadline).foregroundColor(Color.orange).bold().shadow(radius: 10)
                                    }
                                    //Pausar
                                    VStack{
                                        Button(action:{
                                            self.today.empezarDescanso()
                                            self.expand.toggle()
                                        }){
                                            Image(systemName: "pause.circle")
                                                .resizable()
                                                .padding()
                                                .frame(width: 60, height: 60)
                                            
                                        }
                                        .foregroundColor(Color.white)
                                        .background(Color.green)
                                        .clipShape(Circle()).shadow(radius: 10)
                                        
                                        Text("Pausar").font(.subheadline).foregroundColor(Color.green).bold().shadow(radius: 10)
                                    }
                                    .padding(.horizontal,10)
                                }
                                
                                ZStack{
                                    Circle().foregroundColor(Color.orange).frame(width: 90, height: 90).shadow(radius: 10)
                                    Text("Fichar").foregroundColor(.white)
                                        .font(.custom("Arial", size: 22))
                                }.onTapGesture{
                                    self.expand.toggle()
                                }
                                .onLongPressGesture {
                                    self.isButton.toggle()
                                }
                                
                                
                                }.padding(.horizontal).padding(.vertical,30)
                        }
                        
                    }else{
                        HStack{
                            //Botón expandido
                            if self.expand{
                                //GPS
                                VStack{
                                    Button(action:{
                                        if self.geoCode.isEmpty{
                                            self.textAlert = """
                                            Error:
                                            Su perfil no puede iniciar la jornada con geolocalización. Actualice su perfil o póngase en contacto con un administrador.
                                            """
                                            self.showAlert.toggle()
                                           
                                        }else{
                                            self.today.empezarDia(isGPS: true)
                                            self.expand.toggle()
                                        }
                                       
                                    }){
                                        VStack{
                                            Image(systemName: "mappin.and.ellipse")
                                                .resizable()
                                                .padding()
                                                .frame(width: 60, height: 60)
                                        }
                                        
                                        
                                    }.alert(isPresented: self.$showAlert){
                                        Alert(title: Text("Fichajes"), message: Text(self.textAlert), dismissButton: .default(Text("Aceptar"), action: {
                                             self.expand.toggle()
                                        }))
                                    }
                                    .foregroundColor(Color.white)
                                    .background(Color("ColorLogo"))
                                    .clipShape(Circle()).shadow(radius: 10)
                                    
                                    Text("GPS").font(.subheadline).foregroundColor(Color("ColorLogo")).bold().shadow(radius: 10)
                                }
                                //QRCode
                                VStack{
                                    Button(action:{
                                      //self.today.empezarDia(isGPS: false)
                                        self.showQR.toggle()
                                        self.expand.toggle()
                                    }){
                                        Image(systemName: "qrcode.viewfinder")
                                            .resizable()
                                            .padding()
                                            .frame(width: 60, height: 60)
                                        
                                    }
                                    .foregroundColor(Color.white)
                                    .background(Color("ColorLogo"))
                                    .clipShape(Circle()).shadow(radius: 10)
                                    
                                    Text("QR Code").font(.subheadline).foregroundColor(Color("ColorLogo")).bold().shadow(radius: 10)
                                }
                                .padding(.horizontal,20)
                            }
                            
                            ZStack{
                                
                                Circle().foregroundColor(Color("ColorLogo")).frame(width: 90, height: 90).shadow(radius: 10)
                                Text("Fichar").foregroundColor(.white)
                                    .font(.custom("Arial", size: 22))
                            }.onTapGesture{
                                self.expand.toggle()
                            }
                            .onLongPressGesture {
                                self.isButton.toggle()
                            }
                            
                            
                        }.padding(.horizontal).padding(.vertical,30)
                    }
                    
                }
                
            }
        }

    }
    
}

struct BotoView_Previews: PreviewProvider {
    static var previews: some View {
        BotonView()
    }
}
