//
//  MultiTextField.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 16/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//
// Esta estructura permite la creación de campos de texto multilinea para
// la aplicación


import Foundation
import SwiftUI

struct MultiTextField : UIViewRepresentable {
    
    @Binding var text : String
    var texto: String = ""
    
    func makeCoordinator() -> MultiTextField.Coordinator {
        return MultiTextField.Coordinator(conexion: self)
    }
    
    func makeUIView(context: UIViewRepresentableContext<MultiTextField>) -> UITextView {
        let text = UITextView()
        text.isEditable = true
        text.isUserInteractionEnabled = true
        text.text = "\(self.texto)"
        text.textColor = .black
        text.font = .systemFont(ofSize: 16)
        text.delegate = context.coordinator
        return text
    }
    
    func updateUIView(_ uiView: UITextView, context: UIViewRepresentableContext<MultiTextField>) {
        
    }
    
    class Coordinator: NSObject, UITextViewDelegate {
        
        var conexion : MultiTextField
        
        init(conexion : MultiTextField) {
            self.conexion = conexion
        }
        
        func textViewDidBeginEditing(_ textView: UITextView) {
            textView.text = ""
            textView.textColor = .black
        }
        
        func textViewDidChange(_ textView: UITextView) {
            self.conexion.text = textView.text
        }
        
    }
    
}
