//
//  TabBarView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 20/03/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct TabBarView: View {
    
    @Binding var index: Int
    
    var body: some View {
        
        HStack{
            
            Button(action:{
                self.index = 0
                
            }){
                VStack{
                    if self.index != 0{
                        VStack{
                            Image(systemName: "timer")
                                .resizable()
                                .frame(width: 30, height: 30)
                                .foregroundColor(Color.black).opacity(0.3)
                            Text("Horario").foregroundColor(Color.black).opacity(0.3)
                                .font(.custom("Arial", size: 12))
                        }.padding(.top)
                        
                    }else{
                        VStack{
                            Image(systemName: "timer")
                                .resizable()
                                .frame(width: 35, height: 35)
                                .padding(10)
                                .foregroundColor(Color.white)
                                .background(Color("ColorLogo"))
                                .clipShape(Circle())
                                .offset(y:-15)
                            
                            Text("Horario").font(.custom("Arial", size: 15))
                                .offset(y:-20)
                        }
                    }
                }
                
                
            }
            Spacer()
            Button(action:{
                self.index = 1
                
                
            }){
                VStack{
                    if self.index != 1{
                        VStack{
                            Image(systemName: "bubble.left.and.bubble.right.fill")
                                .resizable()
                                .frame(width: 30, height: 30)
                                .foregroundColor(Color.black).opacity(0.3)
                            Text("Ausencias").foregroundColor(Color.black).opacity(0.3)
                                .font(.custom("Arial", size: 12))
                        }.padding(.top)
                        
                    }else{
                        Image(systemName: "bubble.left.and.bubble.right.fill")
                            .resizable()
                            .frame(width: 35, height: 35)
                            .padding(10)
                            .foregroundColor(Color.white)
                            .background(Color("ColorLogo"))
                            .clipShape(Circle())
                            .offset(y:-15)
                        
                        Text("Ausencias").padding(.horizontal).font(.custom("Arial", size: 15))
                            .offset(y:-20)
                    }
                }
                
                
                
            }
            Spacer()
            Button(action:{
                self.index = 2
                
            }){
                VStack{
                    if self.index != 2{
                        VStack{
                            Image(systemName: "calendar")
                                .resizable()
                                .frame(width: 30, height: 30)
                                .foregroundColor(Color.black).opacity(0.3)
                            Text("Agenda").foregroundColor(Color.black).opacity(0.3)
                                .font(.custom("Arial", size: 12))
                        }.padding(.top)
                        
                    }else{
                        Image(systemName: "calendar")
                            .resizable()
                            .frame(width: 35, height: 35)
                            .padding(10)
                            .foregroundColor(Color.white)
                            .background(Color("ColorLogo"))
                            .clipShape(Circle())
                            .offset(y:-15)
                        
                        Text("Agenda")
                            .offset(y:-20)
                    }
                }
                
            }
            Spacer()
            Button(action:{
                self.index = 3
                
            }){
                VStack{
                    if self.index != 3{
                        VStack{
                            Image(systemName: "person.2.square.stack")
                                .resizable()
                                .frame(width: 30, height: 30)
                                .foregroundColor(Color.black).opacity(0.3)
                            Text("Proyectos").foregroundColor(Color.black).opacity(0.3)
                                .font(.custom("Arial", size: 12))
                        }.padding(.top)
                        
                    }else{
                        Image(systemName: "person.2.square.stack")
                            .resizable()
                            .frame(width: 35, height: 35)
                            .padding(10)
                            .foregroundColor(Color.white)
                            .background(Color("ColorLogo"))
                            .clipShape(Circle())
                            .offset(y:-15)
                        
                        Text("Proyectos").padding(.horizontal).font(.custom("Arial", size: 15))
                            .offset(y:-20)
                    }
                }
                
            }
            Spacer()
            Button(action:{
                self.index = 4
                
            }){
                VStack{
                    if self.index != 4{
                        VStack{
                            Image(systemName: "square.and.pencil")
                                .resizable()
                                .frame(width: 30, height: 30)
                                .foregroundColor(Color.black).opacity(0.3)
                            Text("Tablón").foregroundColor(Color.black).opacity(0.3)
                                .font(.custom("Arial", size: 12))
                        }.padding(.top)
                        
                    }else{
                        Image(systemName: "square.and.pencil")
                            .resizable()
                            .frame(width: 35, height: 35)
                            .padding(10)
                            .foregroundColor(Color.white)
                            .background(Color("ColorLogo"))
                            .clipShape(Circle())
                            .offset(y:-15)
                        
                        Text("Tablón")
                            .offset(y:-20)
                    }
                }
                
            }
            
        }
            
        .padding(.top,-10)
        .padding(.horizontal,25)
        .padding(.bottom)
        .background(Color("Barras"))
        .background(Rectangle().stroke(Color("Fondo"), lineWidth: 1))
    }
    
}


struct TabBarView_Previews: PreviewProvider {
    static var previews: some View {
        TabBarView(index: .constant(0))
    }
}
