//
//  UserFrameView.swift
//  ControlWork
//
//  Created by Edu Perianes Lázaro on 22/04/2020.
//  Copyright © 2020 Edu Perianes Lázaro. All rights reserved.
//

import SwiftUI

struct UserFrameView: View {
    
    var name: String = "Edu"
    var mail: String = "eperianes@"
    
    //funcion que recupera la subcadena hasta la @ de un email
    private func subString(mail:String) -> String{
        let marca = mail.firstIndex(of: "@")!
        let nombre = mail[...marca]
        return String(nombre)
    }
    
    var body: some View {
        
            VStack{
                Image(systemName: "person.crop.circle")
                    .resizable()
                    .frame(width: 60, height: 60)
                
                Text(self.name).bold()
                Text(self.subString(mail: self.mail)).font(.footnote)
        }
            .frame(width: 100, height: 150, alignment: .center)
            .background(Color("Fondo"))
            .cornerRadius(10)
            .shadow(radius: 2)
        
    }
}

struct UserFrameView_Previews: PreviewProvider {
    static var previews: some View {
        UserFrameView()
    }
}
